#include <stdio.h>
#include <math.h>
#include <string.h>
#include "fuggveny.h"


/* globlis vltoz a parabola() fggvny szmra.
 * ezekre azrt van szksg, mert a parabola is egy y=f(x)
 * alak fggvny kell legyen, vagyis csak egy paramtere
 * lehet (az x). az egytthatkat ms mdon kell megadni neki. */
struct {
    double a, b, c;
} parabola_adat;

/** Visszaadja x*x-x-1.5 rtkt.
 * @param x A szm, amit a fggvnybe be kell helyettesteni.
 * @return A fggvny rtke. */
static double parabola(double x)
{
    return parabola_adat.a*x*x + parabola_adat.b*x + parabola_adat.c;
}


/** Kirja a felhasznli ment (fmen), s megkrdezi a felhasznl vlasztst.
 * @return A vlasztott men sorszma, vagy 0 a kilpshez (s hiba esetn). */
static int menu(void)
{
    int valaszt, sik;

    printf("Men (0: kilps)\n");
    printf("  1. sin(x) rajzolsa\n");
    printf("  2. axx+bx+c parabola rajzolsa\n");
    printf("  3. Trls\n");
    printf("  4. Fjlba ments\n");
    printf("? ");
    /* A men szmnak beolvassa. Az utna nyomott entert a getchar() lenyeli. */
    sik = scanf("%d", &valaszt)==1;
    getchar();
    /* Beolvassi hiba? 0-t adunk vissza (kilpsnek megfelel) */
    if (!sik)
        return 0;
    /* Tartomny ok? Ha nem, 0-t ad vissza */
    if (valaszt>4 || valaszt<0)
        return 0;
    /* A vlasztott menpont */
    return valaszt;
}


/**
 * Fprogram. */
int main(int argc, char *argv[])
{
    enum { FAJLNEV_TOMB = 100 };
    char fajlnev[FAJLNEV_TOMB];
    Rajz r1;
    int v;

    rajz_inicializal(&r1, 320, 120, 160, 60, 25, 25);

    v = menu();
    while (v!=0) {
        switch (v) {
            case 1:
                fuggveny_rajzol(&r1, sin, "blue");
                break;
            case 2:
                printf("A parabola egytthati:\n");
                scanf("%lf %lf %lf", &parabola_adat.a,
                    &parabola_adat.b, &parabola_adat.c);
                fuggveny_rajzol(&r1, parabola, "red");
                break;
            case 3:
                rajz_torol(&r1);
                break;
            case 4:
                printf("Mi legyen a fjl neve?\n");
                fgets(fajlnev, FAJLNEV_TOMB, stdin);
                /* fgets bele teszi az entert is, kitoroljuk */
                *strchr(fajlnev, '\n') = 0;
                rajz_fajlba(&r1, fajlnev);
                break;
        }

        /* kvetkez */
        v = menu();
    }

    return 0;
}

